SystemOrganization addCategory: #SourceCity!

TestCase subclass: #BuildingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 15:24'!
testColorMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = #2. 
	

	(c city districts) do:[
		:eachDistrict|
		((eachDistrict model) classes) do:[
			:eachBuilding|
			c importClassAsBuilding: eachBuilding district: eachDistrict.
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = #2.
	self assert: (c city districts at:1) widthSelector = #2.
	self assert: ((c city districts at:1) buildings at:1) colorSelector =0.
	self assert: ((c city districts at:1) buildings at:2) colorSelector =0.! !

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 15:23'!
testHeightMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core').
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = 2. 

	(c city districts) do:[
		:eachDistrict|
		eachDistrict buildings do:[
			:eachBuilding|
			Transcript cr;show: eachBuilding.
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = #2.
	self assert: (c city districts at:1) widthSelector = #2.
	self assert: ((c city districts at:1) buildings at:1) heightSelector =  ((c city districts at:1) buildings at:1) model selectors size.
	self assert: ((c city districts at:1) buildings at:2) heightSelector =  ((c city districts at:1) buildings at:2) model selectors size.! !

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 15:25'!
testWidthMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = #2. 
	

	(c city districts) do:[
		:eachDistrict|
		((eachDistrict model) classes) do:[
			:eachBuilding|
			c importClassAsBuilding: eachBuilding district: eachDistrict. 
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = #2.
	self assert: (c city districts at:1) widthSelector = #2.
	self assert: ((c city districts at:1) buildings at:1) widthSelector = #1"((c city districts at:1) buildings at:1) model allSubclasses size".
	self assert: ((c city districts at:1) buildings at:2) widthSelector =  #1"((c city districts at:1) buildings at:2) model allSubclasses size".! !

TestCase subclass: #CityImporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/4/2012 16:58'!
testDisplayFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	
	| cimport ring build height |
	cimport := CityImporter new.
	ring := RPackageOrganizer default packageNames.
	cimport cityNamed: 'CodCT' withPackageNames: ring.
	(cimport city districts) do:[
		:each|
		((each model) classes) do:[
			:eachClass|
			cimport importClassAsBuilding: eachClass district: each.
			].
		].
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[
		:each|
		(each buildings) do:[
			:eachClass|
			build := build+1.
			(height<eachClass heightSelector)
			ifTrue: [height := (eachClass heightSelector).Transcript cr;show:eachClass;show:height].
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 13:08'!
testFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	"This method test, is just for show us what does normal import realize. How many build, districts ... and max metrics we can find"
	| cimport ring build height |
	cimport := CityImporter new.
	ring := RPackageOrganizer default packageNames.
	cimport cityNamed: 'CodCT' withPackageNames: ring.
	
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[
		:each|
		(each buildings) do:[
			:eachClass|
			build := build+1.
			(height<eachClass heightSelector)
			ifTrue: [height := (eachClass heightSelector).Transcript cr;show:eachClass;show:height].
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 13:01'!
testImportClassAsBuilding
	"self debug: #testImportClassAsBuilding"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city districts at: 1)buildings size = cimport numberOfBuilding.
	
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 10:59'!
testImportPackageAsDistrict
	"self debug: #testImportPackageAsDistrict"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 10:59'!
testImportPackageAsDistrictNoDuplicate
	"self debug: #testImportPackageAsDistrictNoDuplicate"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' 'SourceCity' 'AST-Core').
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity').
	! !

TestCase subclass: #DistrictTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!DistrictTest methodsFor: 'tests' stamp: 'douaille 4/10/2012 15:01'!
testMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: c city districts size =1.
	self assert: c city widthSelector = 2. ! !

NBExternalStructure variableByteSubclass: #GLCityStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLCityStructure class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 13:38'!
fieldsDesc
  ^ #( 
         float r;
         float g;
         float b;
         float a;
        )! !

!GLCityStructure methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 13:30'!
fieldsDesc
  ^ #( 
         float r;
         float g;
         float b;  
	   float a.
       
        )! !

NBExternalStructure variableByteSubclass: #GLFloatRGBA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLFloatRGBA class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat r;
         NBGLFloat g;
         NBGLFloat b;  
	   NBGLFloat a;      
        )! !

NBExternalStructure variableByteSubclass: #GLFloatShinines
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLFloatShinines class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat  r;
        )! !

NBExternalStructure variableByteSubclass: #GLFloatVector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLFloatVector class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:14'!
fieldsDesc
  ^ #( 
         NBGLFloat x;
         NBGLFloat y;
         NBGLFloat z;  
        )! !

!Float methodsFor: '*SourceCity' stamp: 'douaille 4/10/2012 14:35'!
roundedUp
	"Return a rounded up"
	self fractionPart abs = 0.0
	ifTrue: [
		^self truncated
		]
	ifFalse: [
		^self truncated + self sign rounded
		]! !

GLViewportMorph subclass: #BackupGLCity
	instanceVariableNames: 'rotationAngle textId xrot yrot zrot face top down xtran ytran ztran znumb ynumb xnumb grass model frameCount font frameStats start'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: xrot x: 1 y: 0  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
building: anArray
	|gl x z y |
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: face. 	
	gl begin: GL_QUADS.
	
		"front"
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(1 1).
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(0 1).
		
		"back"
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(0 1).
	
		"left maybe reverse with right"
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(0 1).
	
		"right maybe reverse with left"
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(1 0).
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(1 1).
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 1).
		
	gl end.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: down.
	gl begin: GL_QUADS.
		"down"
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 1).
	gl end.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: top. 		
	gl begin: GL_QUADS.	
		"top"
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(0 1).
	gl end.! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
buildingColor: anArray color: anArrayColor
	|gl x z y |
	
	gl := display gl.
	
	gl begin: GL_QUADS;
		"front"
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x: anArray first y: 0.1 z: anArray third;
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x: anArray first y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+1 y: anArray second z: anArray third;
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x: (anArray first)+1 y: 0.1 z: anArray third;
		
		"back"
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+1;
		vertex3d_x:  (anArray first)+1 y: 0.1 z: (anArray third)+1;
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x:  (anArray first)+1 y: anArray second z: (anArray third)+1;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+1;
	
		"left maybe reverse with right"
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x:  (anArray first)+1 y: 0.1 z: anArray third;
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x:  (anArray first)+1 y: anArray second z: anArray third;
		vertex3d_x:  (anArray first)+1 y: anArray second z: (anArray third)+1;
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x:  (anArray first)+1 y: 0.1 z: (anArray third)+1;
	
		"right maybe reverse with left"
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+1;
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+1;
		vertex3d_x:  anArray first y: anArray second z: anArray third ;
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x:  anArray first y: 0.1 z: anArray third ;
		
		color3f_red: 0 green: 0 blue: 1; 
		"down"
		vertex3d_x:  anArray first y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+1 y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+1 y: 0.1 z: (anArray third)+1;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+1;
		
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		"top"
		vertex3d_x: anArray first y: anArray second z: anArray third ;
		vertex3d_x: anArray first y: anArray second z: (anArray third)+1;
		vertex3d_x: (anArray first)+1 y: anArray second z: (anArray third)+1;
		vertex3d_x: (anArray first)+1 y: anArray second z: anArray third ;
	end.! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
captureKey: e

	(e keyString = '<left>')
		ifTrue:[ self rotateLeft].
	(e keyString  = '<down>')
		ifTrue:[self rotateDown].
	(e keyString  = '<up>')
		ifTrue:[self rotateTop].
	(e keyString  = '<right>')
		ifTrue:[self rotateRight].
	(e keyString  = '<Shift-right>')
		ifTrue:[self translateRight].
	(e keyString  = '<Shift-left>')
		ifTrue:[self translateLeft].
	(e keyString  = '<Shift-up>')
		ifTrue:[self translateTop].
	(e keyString  = '<Shift-down>')
		ifTrue:[self translateDown].
	(e keyString  = ' ')
		ifTrue:[self translateForward].
	(e keyString  = '<' )
		ifTrue:[self translateBackward].! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
changeModel: aNewRing
	model := aNewRing! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
city: anArrayStart to: anArrayEnd
	|gl|
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: city. 			
	gl begin: GL_QUADS.
		
		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).

	gl end.
	! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
cityColor: anArrayStart to: anArrayEnd color: anArrayColor
	|gl|
	
	gl := display gl.	
	gl begin: GL_QUADS;
		
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;

	end.
	! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
cubicMatrix
	^ThreeDimensionalMatrix new
	 add: {-1. -1. 1};
	 add: {1. -1. 1};
	 add: {1. 1. 1};
	 add: {-1. 1. 1};
	
	 add: {-1. -1. -1};
	 add: {-1. 1. -1};
	 add: {1. 1. -1};
	 add: {1.-1. -1};
	
	  add: {-1. 1. -1};
	  add: {-1. 1. 1};
	  add: {1. 1. 1};
	  add: {1. 1. -1};
	
	  add: {-1. -1. -1};
	  add: {1. -1. -1};
	  add: {1. -1. 1};
	  add: {-1. -1. 1};
	
	  add: {1. -1. -1};
	  add: {1. 1. -1};
	  add: {1. 1. 1};
	  add: {1. -1. 1};
	
	  add: {-1. -1. -1};
	  add: {-1. -1. 1};
	  add: {-1. 1. 1};
	  add: {-1. 1. -1};
	yourself! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: district. 	
	gl begin: GL_QUADS.

		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).
		
		self vertex: { anArrayStart first . anArrayEnd second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayStart first . anArrayEnd second . anArrayEnd third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayStart third } texCoord: #(0 1).

	gl end.	! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
districtColor: anArrayStart to: anArrayEnd color: anArrayColor
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;

	end.! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
drawBuilding: aDistrict gap: gap x: x z: z dxSize: dxSize

		
	| bxSize bzSize|
	bxSize := x +1 .
	bzSize := z +1.
	aDistrict buildings do: [:building |
		(dxSize < (bxSize+2))
		ifTrue: [
			bzSize := bzSize + gap.
			self buildingColor: { x+1 . (building heightSelector asInteger) . bzSize } color: building colorSelector.
			bxSize := x +3.
		]
		ifFalse: [
			self buildingColor: { bxSize . (building heightSelector asInteger) . bzSize } color: building colorSelector.
			bxSize := bxSize + gap.
		].
	].! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
drawCity: anImporter
	
	|sizeArray|
	
	sizeArray := self drawDistrict: anImporter city gap: 2.
	"self city_x: anImporter city widthSelector asInteger y: -0.2 z: anImporter city widthSelector asInteger."
	self cityColor: {-1 . -0.1 . -1} to: sizeArray color: anImporter city colorSelector.! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
drawDistrict:aCity gap: gap

	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize |
	
	x := 0.
	z := 0.
	maxdzSize := 0.
	maxdxSize := 0.
		
	aCity districts do:[:district |
		dxSize := x + (district widthSelector asInteger*2)+1.
		dzSize := z + (district widthSelector asInteger*2)+1.
		self districtColor: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize} color: district colorSelector.
		
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		
		self drawBuilding: district gap: gap x: x z: z dxSize: dxSize.
		
		x := dxSize + gap.
		( x > 200"(aCityImporter city widthSelector asInteger/2)")
		ifTrue: [
			z := maxdzSize + gap.
			(maxdxSize<x)
			ifTrue: [
				maxdxSize := x+(dxSize - x).
			].
			x := 0.
		]
		ifFalse: [
			(maxdxSize<x)
			ifTrue: [
				maxdxSize := x.
			].
		].
	].
	^{maxdxSize+1 . 0 . maxdzSize+1}! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
drawText: aString to: anArray
	| gl |
	self checkSession.

	gl := display gl.
	curveRenderer ifNotNil: [  | g adv |
		gl color3f_red: 0 green:  0 blue: 0. 
		gl scalef_x: 0.01 y: -0.01  z: 1.
		gl translatef_x: anArray first y: anArray second z: anArray third. 
		adv := 0.
		aString do:  [:ch |
			g := font at: ch.
			glyphCache renderGlyph: g.
			gl translatef_x: g advanceWidth y: 0 z:0.
		].
	].
	
	
! !

!BackupGLCity methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 4/23/2012 10:20'!
frameStats
	^frameStats! !

!BackupGLCity methodsFor: 'initialize' stamp: 'DouailleErwan 4/23/2012 10:20'!
initialize
	| fontPath |
	
	super initialize.
	model := CityImporter new cityNamed: 'CodCT' withPackageNames: (RPackageOrganizer default packageNames).
	xrot := -196.
	yrot := -15.
	zrot := 0.
	xtran := 0.
	ytran := 30.
	ztran := -384.
	self on: #keyStroke send: #captureKey: to: self.
	
	frameCount := 0.	
	start := Time millisecondClockValue.
	frameStats := OrderedCollection new:1000.
	
	fontPath := self platformDefaultFontsPath.	
	font := NBTTFontReader readFrom:  
		(FileStream readOnlyFileNamed: fontPath , 'Tahoma.ttf').
	! !

!BackupGLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/23/2012 10:20'!
initializeForNewSession
	super initializeForNewSession.
	self loadTexture.
	self loadText.
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!BackupGLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/23/2012 10:20'!
loadText
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
loadTexture
	
	| buffer fileForm gl fileFormGrass fileFormFace fileFormTop fileFormDown buffer2 buffer3 fileFormDistrict fileFormCity |
	fileFormGrass := (PNGReadWriter formFromFileNamed: 'grass.png').
	fileFormFace := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormTop := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormDown := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormDistrict := (PNGReadWriter formFromFileNamed: 'district.png').
	fileFormCity := (PNGReadWriter formFromFileNamed: 'city.png').
	
	gl := display gl.
	buffer := ByteArray new: 24.	
	gl genTextures_n: 6 textures: buffer.
	 
	face := buffer nbUlongAt: 1. 
	top := buffer nbUlongAt: 5.
	down := buffer nbUlongAt: 9.
	grass := buffer nbUlongAt: 13.
	city := buffer nbUlongAt: 17.
	district := buffer nbUlongAt: 21.
	
	gl bindTexture_target:  GL_TEXTURE_2D texture: face.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormFace width) height: (fileFormFace height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormFace bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	
	gl bindTexture_target:  GL_TEXTURE_2D texture: top.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormTop width) height: (fileFormTop height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormTop bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: down.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormDown width) height: (fileFormDown height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormDown bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: grass.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormGrass width) height: (fileFormGrass height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormGrass bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: city.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormCity width) height: (fileFormCity height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormCity bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR."
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_WRAP_S param: GL_REPEAT;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_WRAP_T param: GL_REPEAT."

	gl bindTexture_target:  GL_TEXTURE_2D texture: district.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormDistrict width) height: (fileFormDistrict height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormDistrict bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	self assert: (gl getError = GL_NO_ERROR)! !

!BackupGLCity methodsFor: 'initialize' stamp: 'DouailleErwan 4/23/2012 10:20'!
openInWorld
	| window |

	window := super openInWorld.
	
	self startStepping.
	self takeKeyboardFocus! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!BackupGLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/23/2012 10:20'!
platformDefaultFontsPath

	NativeBoost platformId == NativeBoostConstants win32PlatformId ifTrue: [
		^ 'C:\Windows\Fonts\'
		].
	
	NativeBoost platformId == NativeBoostConstants mac32PlaformId ifTrue: [
		^ '/Library/Fonts/'
		].
! !

!BackupGLCity methodsFor: 'rendering' stamp: 'DouailleErwan 4/23/2012 10:20'!
render

	| gl cimport ring diffuse specular shinines l_pos t |
	self checkSession.

	"
  	diffuse := GLFloatRGBA new.
	diffuse r: 0.5; g: 0.5;b: 0.5; a:1. 	
	specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 		
	shinines:= GLFloatRGBA new.
	shinines r: 500. 	
	l_pos := GLFloatVector new.
	l_pos x: 5; y: 0;z: 5. 	
	"
	gl := display gl.
	gl 
		
		enable: GL_MULTISAMPLE ;			
		clearDepth: 1; 
		"
		materialfv_face: GL_FRONT pname: GL_DIFFUSE params: diffuse;
		materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS params: shinines;
		lightfv_light: GL_LIGHT0  pname: GL_POSITION  params: l_pos;
		lightfv_light: GL_LIGHT0  pname: GL_DIFFUSE  params: diffuse;
		
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;"
		
		shadeModel: GL_SMOOTH;		
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true;
		
		enable: GL_NORMALIZE.						

	gl 
		clearColor_red: 1 green:  1 blue:  1 alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.

	
	gl matrixMode: GL_PROJECTION; 						
		loadIdentity.	
			
	self perspectiveFovY: 100.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 10000.0.

	gl matrixMode: GL_MODELVIEW. 						
	gl loadIdentity.	


	self applyCamera.
	
	self drawCity: model.
	"t := Time millisecondClockValue.
	frameStats add: t.	
	[ t - frameStats first > 5000 ] whileTrue: [ frameStats removeFirst ].
Transcript cr;show: frameStats."


	"self showSystem: cimport."
	gl flush! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
rotateDown

	xrot := xrot + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
rotateLeft

	yrot := yrot + 1.
	"display gl rotatef_angle: xrot x: 1 y: 0  z: 0."! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
rotateRight
	
	yrot := yrot - 1.
	"display gl rotatef_angle: xrot x: 1 y: 0  z: 0. "! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
rotateTop
	xrot := xrot - 1.
	"display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
showSystem: aCityImporter

	| x y |
	x := 0.
	y := 0.
	aCityImporter city districts do:[:district |
		y := y +1.5.
		x := 0.
		district buildings do:[:building |
			self drawCubeAt: { x . building heightSelector . y}.
			x := x +1.5.
			
		]
	.
	].! !

!BackupGLCity methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 4/23/2012 10:20'!
step
	self changed! !

!BackupGLCity methodsFor: 'testing' stamp: 'DouailleErwan 4/23/2012 10:20'!
stepTime
	^5! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
translateBackward

	ztran := ztran - 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
translateDown

	ytran := ytran + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
translateForward

	ztran := ztran + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
translateLeft

	xtran := xtran - 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
translateRight

	xtran := xtran + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!BackupGLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/23/2012 10:20'!
translateTop

	ytran := ytran - 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!BackupGLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:20'!
vertex: array texCoord: t

	display gl 
		texCoord2d_s:  t first t:  t second;
		vertex3d_x: array first y: array second  z: array third! !

GLViewportMorph subclass: #GLCity
	instanceVariableNames: 'rotationAngle textId xrot yrot zrot face top down xtran ytran ztran znumb ynumb xnumb grass model frameCount font frameStats start'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLCity commentStamp: '<historical>' prior: 0!
A GLCity is a class which display the city with OpenGL, this class use camera and key handler!

!GLCity methodsFor: 'camera' stamp: 'douaille 4/7/2012 16:42'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: xrot x: 1 y: 0  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/17/2012 15:22'!
building: anArray
	|gl x z y |
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: face. 	
	gl begin: GL_QUADS.
	
		"front"
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(1 1).
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(0 1).
		
		"back"
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(0 1).
	
		"left maybe reverse with right"
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(0 1).
	
		"right maybe reverse with left"
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(1 0).
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(1 1).
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 1).
		
	gl end.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: down.
	gl begin: GL_QUADS.
		"down"
		self vertex: { anArray first . 0 . anArray third } texCoord: #(0 0).
		self vertex: { (anArray first)+1 . 0 . anArray third } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . 0 . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { anArray first . 0 . (anArray third)+1 } texCoord: #(0 1).
	gl end.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: top. 		
	gl begin: GL_QUADS.	
		"top"
		self vertex: { anArray first . anArray second . anArray third } texCoord: #(0 0).
		self vertex: { anArray first . anArray second . (anArray third)+1 } texCoord: #(1 0).
		self vertex: { (anArray first)+1 . anArray second . (anArray third)+1 } texCoord: #(1 1).
		self vertex: { (anArray first)+1 . anArray second . anArray third } texCoord: #(0 1).
	gl end.! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:43'!
buildingColor: anArray color: anArrayColor
	|gl x z y |
	
	gl := display gl.
	
	gl begin: GL_QUADS;
		"front"
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x: anArray first y: 0.1 z: anArray third;
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x: anArray first y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+1 y: anArray second z: anArray third;
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x: (anArray first)+1 y: 0.1 z: anArray third;
		
		"back"
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+1;
		vertex3d_x:  (anArray first)+1 y: 0.1 z: (anArray third)+1;
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x:  (anArray first)+1 y: anArray second z: (anArray third)+1;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+1;
	
		"left maybe reverse with right"
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x:  (anArray first)+1 y: 0.1 z: anArray third;
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x:  (anArray first)+1 y: anArray second z: anArray third;
		vertex3d_x:  (anArray first)+1 y: anArray second z: (anArray third)+1;
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x:  (anArray first)+1 y: 0.1 z: (anArray third)+1;
	
		"right maybe reverse with left"
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+1;
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+1;
		vertex3d_x:  anArray first y: anArray second z: anArray third ;
		color3f_red: 0 green: 0 blue: 1; 
		vertex3d_x:  anArray first y: 0.1 z: anArray third ;
		
		color3f_red: 0 green: 0 blue: 1; 
		"down"
		vertex3d_x:  anArray first y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+1 y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+1 y: 0.1 z: (anArray third)+1;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+1;
		
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		"top"
		vertex3d_x: anArray first y: anArray second z: anArray third ;
		vertex3d_x: anArray first y: anArray second z: (anArray third)+1;
		vertex3d_x: (anArray first)+1 y: anArray second z: (anArray third)+1;
		vertex3d_x: (anArray first)+1 y: anArray second z: anArray third ;
	end.! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/17/2012 19:35'!
captureKey: e

	(e keyString = '<left>')
		ifTrue:[ self rotateLeft].
	(e keyString  = '<down>')
		ifTrue:[self rotateDown].
	(e keyString  = '<up>')
		ifTrue:[self rotateTop].
	(e keyString  = '<right>')
		ifTrue:[self rotateRight].
	(e keyString  = '<Shift-right>')
		ifTrue:[self translateRight].
	(e keyString  = '<Shift-left>')
		ifTrue:[self translateLeft].
	(e keyString  = '<Shift-up>')
		ifTrue:[self translateTop].
	(e keyString  = '<Shift-down>')
		ifTrue:[self translateDown].
	(e keyString  = ' ')
		ifTrue:[self translateForward].
	(e keyString  = '<' )
		ifTrue:[self translateBackward].! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/16/2012 10:48'!
changeModel: aNewRing
	model := aNewRing! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/17/2012 17:25'!
city: anArrayStart to: anArrayEnd
	|gl|
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: city. 			
	gl begin: GL_QUADS.
		
		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).

	gl end.
	! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/18/2012 09:28'!
cityColor: anArrayStart to: anArrayEnd color: anArrayColor
	|gl|
	
	gl := display gl.	
	gl begin: GL_QUADS;
		
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;

	end.
	! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/16/2012 10:19'!
cubicMatrix
	^ThreeDimensionalMatrix new
	 add: {-1. -1. 1};
	 add: {1. -1. 1};
	 add: {1. 1. 1};
	 add: {-1. 1. 1};
	
	 add: {-1. -1. -1};
	 add: {-1. 1. -1};
	 add: {1. 1. -1};
	 add: {1.-1. -1};
	
	  add: {-1. 1. -1};
	  add: {-1. 1. 1};
	  add: {1. 1. 1};
	  add: {1. 1. -1};
	
	  add: {-1. -1. -1};
	  add: {1. -1. -1};
	  add: {1. -1. 1};
	  add: {-1. -1. 1};
	
	  add: {1. -1. -1};
	  add: {1. 1. -1};
	  add: {1. 1. 1};
	  add: {1. -1. 1};
	
	  add: {-1. -1. -1};
	  add: {-1. -1. 1};
	  add: {-1. 1. 1};
	  add: {-1. 1. -1};
	yourself! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/17/2012 17:24'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: district. 	
	gl begin: GL_QUADS.

		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).
		
		self vertex: { anArrayStart first . anArrayEnd second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayStart first . anArrayEnd second . anArrayEnd third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayStart third } texCoord: #(0 1).

	gl end.	! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/18/2012 09:29'!
districtColor: anArrayStart to: anArrayEnd color: anArrayColor
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		
		color3f_red: anArrayColor first asFloat green: anArrayColor second asFloat blue: anArrayColor third asFloat; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;

	end.! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/18/2012 14:52'!
drawBuilding: aDistrict gap: gap x: x z: z dxSize: dxSize

		
	| bxSize bzSize|
	bxSize := x +1 .
	bzSize := z +1.
	aDistrict buildings do: [:building |
		(dxSize < (bxSize+2))
		ifTrue: [
			bzSize := bzSize + gap.
			self buildingColor: { x+1 . (building heightSelector asInteger) . bzSize } color: building colorSelector.
			bxSize := x +3.
		]
		ifFalse: [
			self buildingColor: { bxSize . (building heightSelector asInteger) . bzSize } color: building colorSelector.
			bxSize := bxSize + gap.
		].
	].! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/18/2012 10:06'!
drawCity: anImporter
	
	|sizeArray|
	
	sizeArray := self drawDistrict: anImporter city gap: 2.
	"self city_x: anImporter city widthSelector asInteger y: -0.2 z: anImporter city widthSelector asInteger."
	self cityColor: {-1 . -0.1 . -1} to: sizeArray color: anImporter city colorSelector.! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/18/2012 09:43'!
drawDistrict:aCity gap: gap

	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize |
	
	x := 0.
	z := 0.
	maxdzSize := 0.
	maxdxSize := 0.
		
	aCity districts do:[:district |
		dxSize := x + (district widthSelector asInteger*2)+1.
		dzSize := z + (district widthSelector asInteger*2)+1.
		self districtColor: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize} color: district colorSelector.
		
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		
		self drawBuilding: district gap: gap x: x z: z dxSize: dxSize.
		
		x := dxSize + gap.
		( x > 200"(aCityImporter city widthSelector asInteger/2)")
		ifTrue: [
			z := maxdzSize + gap.
			(maxdxSize<x)
			ifTrue: [
				maxdxSize := x+(dxSize - x).
			].
			x := 0.
		]
		ifFalse: [
			(maxdxSize<x)
			ifTrue: [
				maxdxSize := x.
			].
		].
	].
	^{maxdxSize+1 . 0 . maxdzSize+1}! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/18/2012 15:56'!
drawText: aString to: anArray
	| gl |
	self checkSession.

	gl := display gl.
	curveRenderer ifNotNil: [  | g adv |
		gl color3f_red: 0 green:  0 blue: 0. 
		gl scalef_x: 0.01 y: -0.01  z: 1.
		gl translatef_x: anArray first y: anArray second z: anArray third. 
		adv := 0.
		aString do:  [:ch |
			g := font at: ch.
			glyphCache renderGlyph: g.
			gl translatef_x: g advanceWidth y: 0 z:0.
		].
	].
	
	
! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 4/23/2012 10:46'!
initialize
	| fontPath |
	
	super initialize.
	model := CityImporter new cityNamed: 'CodCT' withPackageNames: (RPackageOrganizer default packageNames).
	xrot := -196.
	yrot := -15.
	zrot := 0.
	xtran := 0.
	ytran := 30.
	ztran := -384.
	self on: #keyStroke send: #captureKey: to: self.
			
	fontPath := self platformDefaultFontsPath.	
	font := NBTTFontReader readFrom:  
		(FileStream readOnlyFileNamed: fontPath , 'Tahoma.ttf').
	! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
initializeForNewSession
	super initializeForNewSession.
	self loadTexture.
	self loadText.
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
loadText
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/17/2012 11:03'!
loadTexture
	
	| buffer fileForm gl fileFormGrass fileFormFace fileFormTop fileFormDown buffer2 buffer3 fileFormDistrict fileFormCity |
	fileFormGrass := (PNGReadWriter formFromFileNamed: 'grass.png').
	fileFormFace := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormTop := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormDown := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormDistrict := (PNGReadWriter formFromFileNamed: 'district.png').
	fileFormCity := (PNGReadWriter formFromFileNamed: 'city.png').
	
	gl := display gl.
	buffer := ByteArray new: 24.	
	gl genTextures_n: 6 textures: buffer.
	 
	face := buffer nbUlongAt: 1. 
	top := buffer nbUlongAt: 5.
	down := buffer nbUlongAt: 9.
	grass := buffer nbUlongAt: 13.
	city := buffer nbUlongAt: 17.
	district := buffer nbUlongAt: 21.
	
	gl bindTexture_target:  GL_TEXTURE_2D texture: face.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormFace width) height: (fileFormFace height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormFace bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	
	gl bindTexture_target:  GL_TEXTURE_2D texture: top.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormTop width) height: (fileFormTop height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormTop bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: down.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormDown width) height: (fileFormDown height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormDown bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: grass.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormGrass width) height: (fileFormGrass height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormGrass bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: city.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormCity width) height: (fileFormCity height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormCity bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR."
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_WRAP_S param: GL_REPEAT;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_WRAP_T param: GL_REPEAT."

	gl bindTexture_target:  GL_TEXTURE_2D texture: district.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormDistrict width) height: (fileFormDistrict height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormDistrict bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	self assert: (gl getError = GL_NO_ERROR)! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 4/17/2012 14:40'!
openInWorld
	| window |

	window := super openInWorld.
	
	self startStepping.
	self takeKeyboardFocus! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/7/2012 16:42'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
platformDefaultFontsPath

	NativeBoost platformId == NativeBoostConstants win32PlatformId ifTrue: [
		^ 'C:\Windows\Fonts\'
		].
	
	NativeBoost platformId == NativeBoostConstants mac32PlaformId ifTrue: [
		^ '/Library/Fonts/'
		].
! !

!GLCity methodsFor: 'rendering' stamp: 'DouailleErwan 4/23/2012 10:46'!
render

	| gl cimport ring diffuse specular shinines l_pos t |
	self checkSession.
	
	gl := display gl.
	gl 		
		enable: GL_MULTISAMPLE ;		
		shadeModel: GL_SMOOTH;		
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.			
	gl 
		clearColor_red: 1 green:  1 blue:  1 alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.
	gl 
		matrixMode: GL_PROJECTION; 						
		loadIdentity.	
			
	self perspectiveFovY: 100.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 10000.0.

	gl matrixMode: GL_MODELVIEW. 						
	gl loadIdentity.	

	self applyCamera.
	
	self drawCity: model.

	gl flush.! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:27'!
rotateDown

	xrot := xrot + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:27'!
rotateLeft

	yrot := yrot + 1.
	"display gl rotatef_angle: xrot x: 1 y: 0  z: 0."! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:27'!
rotateRight
	
	yrot := yrot - 1.
	"display gl rotatef_angle: xrot x: 1 y: 0  z: 0. "! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:27'!
rotateTop
	xrot := xrot - 1.
	"display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/7/2012 16:46'!
showSystem: aCityImporter

	| x y |
	x := 0.
	y := 0.
	aCityImporter city districts do:[:district |
		y := y +1.5.
		x := 0.
		district buildings do:[:building |
			self drawCubeAt: { x . building heightSelector . y}.
			x := x +1.5.
			
		]
	.
	].! !

!GLCity methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 4/23/2012 10:46'!
step
	self changed! !

!GLCity methodsFor: 'testing' stamp: 'DouailleErwan 4/23/2012 10:46'!
stepTime
	^5! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateBackward

	ztran := ztran - 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateDown

	ytran := ytran + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/17/2012 17:30'!
translateForward

	ztran := ztran + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateLeft

	xtran := xtran - 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateRight

	xtran := xtran + 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 4/16/2012 11:28'!
translateTop

	ytran := ytran - 1.
"	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. "
	! !

!GLCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/7/2012 16:42'!
vertex: array texCoord: t

	display gl 
		texCoord2d_s:  t first t:  t second;
		vertex3d_x: array first y: array second  z: array third! !

GLViewportMorph subclass: #GLTest
	instanceVariableNames: 'rot model face top down grass xtran ytran ztran xrot yrot zrot znumb xnumb ynumb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: xrot x: 1 y: 0  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
building_x: x y: y z: z
	|gl|
	
	gl := display gl.
	gl begin: GL_QUADS;
	
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y: 0  z: z; 
		vertex3f_x: x  y: y z: z; 
		vertex3f_x: x+1 y: y z: z; 
		vertex3f_x: x+1 y: 0 z: z; 
		
		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: 0  z: z+1; 
		vertex3f_x: x+1 y:0  z: z+1; 
		vertex3f_x: x+1 y: y z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		
		color3f_red: 1 green: 0 blue: 0;
		vertex3f_x: x+1 y: 0  z: z; 
		vertex3f_x: x+1  y: y z: z; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: 0  z: z+1; 
		
		color3f_red: 1 green: 0 blue: 1; 
		vertex3f_x: x y: 0 z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: 0 z:z; 
		
		color3f_red: 0 green: 1 blue: 1; 
		vertex3f_x: x y: 0  z:z; 
		vertex3f_x: x+1 y: 0 z: z; 
		vertex3f_x: x+1 y: 0 z: z+1; 
		vertex3f_x: x y: 0 z: z+1; 
		
		color3f_red: 1 green: 1 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: y z: z; 

	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
city_x: x y: y z: z
	|gl|
	
	gl := display gl.

	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: grass. 	
		
	gl begin: GL_QUADS;
		
		color3f_red: 1 green: 1 blue: 1; 
		vertex3f_x: -1 y: y  z: -1; 
		texCoord2d_s: 0 t: 0; 
		vertex3f_x: x y:  y z: -1; 
		texCoord2d_s: 0 t: 1; 
		vertex3f_x: x y:  y z: z; 
		texCoord2d_s: 1 t: 1; 
		vertex3f_x: -1 y:  y z: z; 
		texCoord2d_s: 1 t: 0; 
		
		vertex3f_x: -1 y:  y  z: -1; 
		texCoord2d_s: 0 t: 0; 
		vertex3f_x: -1 y:  y z: z; 
		texCoord2d_s: 0 t: 1; 
		vertex3f_x: x y:  y  z: z; 
		texCoord2d_s: 1 t: 1; 
		vertex3f_x: x y:  y z: -1; 
		texCoord2d_s: 1 t: 0; 

	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		
		color3f_red: 0.5 green: 0.5 blue: 0.5; 

		vertex3f_x: anArrayStart first y: anArrayStart second z: anArrayStart third; 
		vertex3f_x: anArrayEnd first y: anArrayStart second z: anArrayStart third; 
		vertex3f_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third; 
		vertex3f_x: anArrayStart first y: anArrayStart second z: anArrayEnd third; 
		
		vertex3f_x: anArrayStart first y: anArrayEnd second z: anArrayStart third; 
		vertex3f_x: anArrayStart first y: anArrayEnd second z: anArrayEnd third; 
		vertex3f_x: anArrayEnd first y: anArrayEnd second z: anArrayEnd third; 
		vertex3f_x: anArrayEnd first y: anArrayEnd second z: anArrayStart third; 

	end.	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:09'!
initialize
	
	super initialize.
	xrot := 0.
	yrot := 0.
	zrot := 0.
	xtran := 0.
	ytran := 0.
	ztran := -50.
	znumb := 0.
	xnumb := 0.
	ynumb := 0.
	
	
	rot := 0.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
line_x: x y: y z: z
	|gl|
	
	gl := display gl.
	
	gl begin: GL_LINES;

		color3f_red: 1 green: 0 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x+1 y: y  z: z; 

		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: y z: z; 
		vertex3f_x: x y: y+1 z: z;
		 
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y:  y z: z; 
		vertex3f_x: x y: y z: z+1;
		
	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
openInWorld

	super openInWorld.
	
	self startStepping.! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/23/2012 10:09'!
render
	|gl curveRenderer x tab y z  cimport diffuse specular shinines l_pos |
	
	gl := display gl.
	display clear: Color black.
	
	
  	diffuse := GLFloatRGBA new.
	diffuse r: 1; g: 1;b: 1; a:1. 	
	specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 		
	shinines:= GLFloatRGBA new.
	shinines r: 0. 	
	l_pos := GLFloatVector new.
	l_pos x: 0; y: 0;z: 0. 	
	
	gl
		enable: GL_CULL_FACE;
		enable: GL_MULTISAMPLE;
		enable: GL_MULTISAMPLE_ARB;
		depthFunc: GL_LEQUAL;
		enable: GL_LINE_SMOOTH;
	
	
		materialfv_face: GL_FRONT pname: GL_DIFFUSE params: diffuse;
		materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS params: shinines;
		lightfv_light: GL_LIGHT0  pname: GL_POSITION  params: l_pos;
		lightfv_light: GL_LIGHT0  pname: GL_DIFFUSE  params: diffuse;
		
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;

		
		"polygonMode_face: GL_FRONT mode: GL_LINE;"

		matrixMode: GL_PROJECTION;
		loadIdentity;
		frustum_left: (self width/2) negated 
		right: (self width/2) 
		bottom: (self width/2) negated
		top: (self width/2)
		zNear: 0
		zFar: self width .			
	gl
		matrixMode: GL_MODELVIEW;
		loadIdentity;
		scalef_x: 1/5.0 y: 1/5.0  z: 1/5.0 .
	gl rotatef_angle: (180) x: 1 y: 1 z: 1.
	gl scalef_x:  1 y: 1  z: 1.
	
	self line_x: -1 y: -1 z: -1.
	x := 0.
	y := 1.
	z := 0.
	gl begin: GL_QUADS;
	
		color3f_red: 0 green: 0 blue: 1; 
		normal3d_nx: 0 ny: 1 nz: 0; 
		vertex3f_x: x y: 0  z: z; 
		vertex3f_x: x  y: y z: z; 
		vertex3f_x: x+1 y: y z: z; 
		vertex3f_x: x+1 y: 0 z: z; 
		
		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: 0  z: z+1; 
		vertex3f_x: x+1 y:0  z: z+1; 
		vertex3f_x: x+1 y: y z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		
		color3f_red: 1 green: 0 blue: 0;
		vertex3f_x: x+1 y: 0  z: z; 
		vertex3f_x: x+1  y: y z: z; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: 0  z: z+1; 
		
		color3f_red: 1 green: 0 blue: 1; 
		vertex3f_x: x y: 0 z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: 0 z:z; 
		
		color3f_red: 0 green: 1 blue: 1; 
		vertex3f_x: x y: 0  z:z; 
		vertex3f_x: x+1 y: 0 z: z; 
		vertex3f_x: x+1 y: 0 z: z+1; 
		vertex3f_x: x y: 0 z: z+1; 
		
		color3f_red: 1 green: 1 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: y z: z; 

	end.! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
step
	rot := rot + 2.
	self changed! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
stepTime
	^ 5! !

GLViewportMorph subclass: #NBCity
	instanceVariableNames: 'rot model face top down grass xtran ytran ztran xrot yrot zrot znumb xnumb ynumb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!NBCity commentStamp: '<historical>' prior: 0!
A NBCity is an OpenGL class who can display a reprensentation of SourceCity.!

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:55'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: xrot x: 1 y: 0  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 16:43'!
building_x: x y: y z: z
	|gl|
	
	gl := display gl.
	gl begin: GL_QUADS;
	
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y: 0  z: z; 
		vertex3f_x: x  y: y z: z; 
		vertex3f_x: x+1 y: y z: z; 
		vertex3f_x: x+1 y: 0 z: z; 
		
		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: 0  z: z+1; 
		vertex3f_x: x+1 y:0  z: z+1; 
		vertex3f_x: x+1 y: y z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		
		color3f_red: 1 green: 0 blue: 0;
		vertex3f_x: x+1 y: 0  z: z; 
		vertex3f_x: x+1  y: y z: z; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: 0  z: z+1; 
		
		color3f_red: 1 green: 0 blue: 1; 
		vertex3f_x: x y: 0 z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: 0 z:z; 
		
		color3f_red: 0 green: 1 blue: 1; 
		vertex3f_x: x y: 0  z:z; 
		vertex3f_x: x+1 y: 0 z: z; 
		vertex3f_x: x+1 y: 0 z: z+1; 
		vertex3f_x: x y: 0 z: z+1; 
		
		color3f_red: 1 green: 1 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: y z: z; 

	end.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:14'!
changeModel: aNewRing
	model := aNewRing! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:48'!
city_x: x y: y z: z
	|gl|
	
	gl := display gl.

	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: grass. 	
		
	gl begin: GL_QUADS;
		
		color3f_red: 1 green: 1 blue: 1; 
		vertex3f_x: -1 y: y  z: -1; 
		texCoord2d_s: 0 t: 0; 
		vertex3f_x: x y:  y z: -1; 
		texCoord2d_s: 0 t: 1; 
		vertex3f_x: x y:  y z: z; 
		texCoord2d_s: 1 t: 1; 
		vertex3f_x: -1 y:  y z: z; 
		texCoord2d_s: 1 t: 0; 
		
		vertex3f_x: -1 y:  y  z: -1; 
		texCoord2d_s: 0 t: 0; 
		vertex3f_x: -1 y:  y z: z; 
		texCoord2d_s: 0 t: 1; 
		vertex3f_x: x y:  y  z: z; 
		texCoord2d_s: 1 t: 1; 
		vertex3f_x: x y:  y z: -1; 
		texCoord2d_s: 1 t: 0; 

	end.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 16:00'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		
		color3f_red: 0.5 green: 0.5 blue: 0.5; 

		vertex3f_x: anArrayStart first y: anArrayStart second z: anArrayStart third; 
		vertex3f_x: anArrayEnd first y: anArrayStart second z: anArrayStart third; 
		vertex3f_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third; 
		vertex3f_x: anArrayStart first y: anArrayStart second z: anArrayEnd third; 
		
		vertex3f_x: anArrayStart first y: anArrayEnd second z: anArrayStart third; 
		vertex3f_x: anArrayStart first y: anArrayEnd second z: anArrayEnd third; 
		vertex3f_x: anArrayEnd first y: anArrayEnd second z: anArrayEnd third; 
		vertex3f_x: anArrayEnd first y: anArrayEnd second z: anArrayStart third; 

	end.	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:09'!
drawBuilding: aDistrict gap: gap x: x z: z dxSize: dxSize

		
	| bxSize bzSize|
	bxSize := x +1 .
	bzSize := z +1.
	aDistrict buildings do: [:building |
		(dxSize < (bxSize+2))
		ifTrue: [
			bzSize := bzSize + gap.
			self building_x: x+1 y: building heightSelector asInteger z: bzSize.
			bxSize := x +3.
		]
		ifFalse: [
			self building_x: bxSize y: building heightSelector asInteger z: bzSize.
			bxSize := bxSize + gap.
		].
	].! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/12/2012 17:01'!
drawCity: anImporter
	
	|sizeArray|
	
	sizeArray := self drawDistrict: anImporter city gap: 2.
	"self city_x: anImporter city widthSelector asInteger y: -0.2 z: anImporter city widthSelector asInteger."
	self city_x: sizeArray first y: -0.2 z: sizeArray second.! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 09:52'!
drawDistrict:aCity gap: gap

	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize |
	
	x := 0.
	z := 0.
	maxdzSize := 0.
	maxdxSize := 0.
		
	aCity districts do:[:district |
		dxSize := x + (district widthSelector asInteger*2)+1.
		dzSize := z + (district widthSelector asInteger*2)+1.
		self district: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize}.
		
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		
		self drawBuilding: district gap: gap x: x z: z dxSize: dxSize.
		
		x := dxSize + gap.
		( x > 200"(aCityImporter city widthSelector asInteger/2)")
		ifTrue: [
			z := maxdzSize + gap.
			(maxdxSize<x)
			ifTrue: [
				maxdxSize := x+(dxSize - x).
			].
			x := 0.
		]
		ifFalse: [
			(maxdxSize<x)
			ifTrue: [
				maxdxSize := x.
			].
		].
	].
	^{maxdxSize+1 . maxdzSize+1}! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:56'!
initialize
	
	model := CityImporter new cityNamed: 'CodCT' withPackageNames: (RPackageOrganizer default packageNames).
	super initialize.
	xrot := 0.
	yrot := 0.
	zrot := 0.
	xtran := 0.
	ytran := 0.
	ztran := -50.
	znumb := 0.
	xnumb := 0.
	ynumb := 0.
	
	
	rot := 0.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:15'!
initialize: aCityImporter
	
	model := aCityImporter.
	super initialize.
	
	rot := 0.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/6/2012 16:32'!
line_x: x y: y z: z
	|gl|
	
	gl := display gl.
	
	gl begin: GL_LINES;

		color3f_red: 1 green: 0 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x+1 y: y  z: z; 

		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: y z: z; 
		vertex3f_x: x y: y+1 z: z;
		 
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y:  y z: z; 
		vertex3f_x: x y: y z: z+1;
		
	end.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:31'!
loadTexture
	
	| buffer fileForm gl fileFormGrass fileFormFace fileFormTop fileFormDown buffer2 buffer3 |
	fileFormGrass := (PNGReadWriter formFromFileNamed: 'grass.png').
	fileFormFace := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormTop := (PNGReadWriter formFromFileNamed: 'bricks.png').
	fileFormDown := (PNGReadWriter formFromFileNamed: 'bricks.png').
	Transcript cr;show:'ok'.
	gl := display gl.
	buffer := ByteArray new: 16.	
	gl genTextures_n: 4 textures: buffer.
	 
	face := buffer nbUlongAt: 1. 
	top := buffer nbUlongAt: 5.
	down := buffer nbUlongAt: 9.
	grass := buffer nbUlongAt: 13.
	
	gl bindTexture_target:  GL_TEXTURE_2D texture: face.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormFace width) height: (fileFormFace height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormFace bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	
	gl bindTexture_target:  GL_TEXTURE_2D texture: top.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormTop width) height: (fileFormTop height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormTop bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: down.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormDown width) height: (fileFormDown height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormDown bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	gl bindTexture_target:  GL_TEXTURE_2D texture: grass.
	gl texImage2D_target: GL_TEXTURE_2D level: 0 internalformat: 4 width: (fileFormGrass width) height: (fileFormGrass height)  border: 0  format: GL_BGRA type: GL_UNSIGNED_BYTE pixels: (fileFormGrass bits). 
	gl 
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MIN_FILTER param: GL_LINEAR;
		texParameteri_target: GL_TEXTURE_2D pname: GL_TEXTURE_MAG_FILTER param: GL_LINEAR.

	self assert: (gl getError = GL_NO_ERROR)! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/6/2012 16:32'!
openInWorld

	super openInWorld.
	
	self startStepping.! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:52'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:55'!
render

	| gl |
	self checkSession.
	gl := display gl.
	gl 
		enable: GL_MULTISAMPLE ;
		shadeModel: GL_SMOOTH;					
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL.
		"depthMask: true.			"					

	gl 
		clearColor_red: 1 green:  1 blue:  1 alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.

	
	gl matrixMode: GL_PROJECTION; 						
		loadIdentity.	
			
	self perspectiveFovY: 45.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 010000.0.

	gl matrixMode: GL_MODELVIEW. 						
	gl loadIdentity.	
	self applyCamera.
	self line_x: -1 y: -1 z: -1.
	self drawCity: model.
	gl flush.
	"
	self drawFullGroundGrassAt: {10 . 1 . 10}.
	self drawHouseAt: { 3 . 2 . 3}."
	"self showSystem."
	
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 16:09'!
step
	rot := rot + 2.
	self changed! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/8/2012 16:44'!
stepTime
	^ 5! !

Object subclass: #CityImporter
	instanceVariableNames: 'classes methods packages city districts buildings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/19/2012 15:45'!
basicBuilding: aClassName district: aDistrict

	 | b |
	b := Building new model:  aClassName;hisDistrict: aDistrict.
	b heightSelector: (aClassName selectors) size.
	"Transcript cr;show: 'hi ';show: aClassName;show: ' - ';show:  (aClassName allInstances) size.(((aClassName asRingDefinition) classVariables) size).(aClassName allInstances) size"
	
	b widthSelector: #1.
	(((aClassName selectors) size) > 10)
	ifTrue: [
		(((aClassName selectors) size) > 20)
		ifTrue: [
			b colorSelector: { (((aClassName selectors) size) /10) . 0 . 0 }
		]
		ifFalse: [
			b colorSelector: { 0. (((aClassName selectors) size) /20)  . 0 }
		].	
	]
	ifFalse: [
		b colorSelector: {  0 . 0 . 1}.	
	].
	aDistrict add: b.
	^b.
	
	"TODO: COLOR
	(aClassName selectors) do:[:each|
		couleur := each li
		
		
	La liste de l'historique de la classe	appel d'une fonction
		d historyArray: aClassName history
		d historyChoice: aClassName history lastVersion"! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/18/2012 10:08'!
basicDistrict: aPackageName city: aCity

	 | d |
	d := District new model: (self packageNamed: aPackageName);hisCity: aCity.
	d heightSelector: #1.
	d widthSelector: #1"aPackageName classes size".
	d colorSelector: { 0.9 . 0.9 . 0.9}.
	city add: d.
	"TODO :
	
	La liste de l'historique du package	appel d'une fonction
		d historyArray: aPackageName history
		d historyChoice: aPackageName history lastVersion"
	^d
	
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:33'!
city
	^city! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/18/2012 10:08'!
cityNamed: aName withPackageNames: aCol

	city := City new model: aName; name: aName.
	city colorSelector: { 0.8 . 0.8 . 0.8 }.
	aCol do: [:each |
				self importPackageAsDistrict: each ].
	self importClassAsBuilding .! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:23'!
districts
	^ city districts.! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:58'!
ensureBuilding: aClassName district: aDistrict

	^ buildings
			at: aClassName 
			ifAbsentPut: [ self basicBuilding: aClassName district: aDistrict].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:48'!
ensureDistrict: aPackageName

	^districts 
			at: aPackageName 
			ifAbsentPut: [ self basicDistrict: aPackageName city: (self city)].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/19/2012 15:37'!
importClassAsBuilding
	(self city districts) do:[
		:each|
		(each model classes) do: [ :eachClass |
			eachClass isBehavior
				ifTrue: [ self importClassAsBuilding: eachClass district: each ]]
			displayingProgress: 'importing classes'
		].! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:56'!
importClassAsBuilding: aClassName district: aDistrict

	| ctPack |
	ctPack := self ensureBuilding: aClassName district: aDistrict.
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/2/2012 15:43'!
importPackageAsDistrict: aPackageName

	| ctPack |
	ctPack := self ensureDistrict: aPackageName.
	! !

!CityImporter methodsFor: 'initialize-release' stamp: 'DouailleErwan 4/3/2012 14:08'!
initialize

	super initialize.
	districts := Dictionary new.
	buildings := Dictionary new.! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/5/2012 10:56'!
numberOfBuilding
	|number|
	number:= 0.
	city districts do:[:each |
		number := number + each buildings size.].
	^number! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/5/2012 10:54'!
numberOfDistrict
	^city districts size! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/2/2012 14:28'!
packageNamed: aString

	^ RPackageOrganizer default packageNamed: aString! !

Object subclass: #CityObject
	instanceVariableNames: 'model widthSelector heightSelector colorSelector historyArray historyChoice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityObject commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

CityObject subclass: #Building
	instanceVariableNames: 'hisDistrict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!Building commentStamp: '<historical>' prior: 0!
A Building is the level abstraction.!

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/18/2012 15:02'!
heightSelector
	^((1 + super heightSelector) ln asInteger) * 2! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:33'!
hisDistrict
	^hisDistrict ! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:04'!
hisDistrict: aDistrict
	hisDistrict := aDistrict.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:40'!
printOn: aStream

	hisDistrict ifNotNil: [ aStream
					nextPutAll: hisDistrict asString; 
					nextPutAll: ' -> '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' Buidling Name : '; 
					nextPutAll: model name].! !

CityObject subclass: #City
	instanceVariableNames: 'districts name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!City commentStamp: '<historical>' prior: 0!
A City represents the largest model element. It contains a list of districts.!

!City methodsFor: 'adding' stamp: 'DouailleErwan 4/18/2012 10:02'!
add: aDistrict

	districts add: aDistrict.
	self widthSelector: (districts size).
	^ aDistrict! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:36'!
districts

	^ districts! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:51'!
districts: anObject
	districts := anObject! !

!City methodsFor: 'testing' stamp: 'DouailleErwan 4/2/2012 14:48'!
hasDistrictNamed: aString
	
	^ districts anySatisfy: [:each | each model name = aString]! !

!City methodsFor: 'initialize-release' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize

	super initialize.
	"districts := Dictionary new."
	districts := OrderedCollection new.! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name
	^ name! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name: anObject
	name := anObject! !

!City methodsFor: 'accessing' stamp: 'douaille 4/10/2012 09:37'!
printOn: aStream

	model ifNotNil: [ aStream 
					nextPutAll: ' City name : '; 
					nextPutAll: self name].! !

!City methodsFor: 'accessing' stamp: 'douaille 4/13/2012 13:47'!
widthSelector
	^super widthSelector sqrt asFloat roundedUp! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
colorSelector
	^colorSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
colorSelector: anObject
	colorSelector := anObject.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
heightSelector
	^heightSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
heightSelector: anObject
	heightSelector := anObject.! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:48'!
historyArray
	^ historyArray! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:48'!
historyArray: anArray
	 historyArray := anArray! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:49'!
historyChoice
	 ^historyChoice! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:49'!
historyChoice: selectedHistory
	 historyChoice := selectedHistory! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize
	
	self widthSelector: #0.
	self colorSelector: #0.
	self heightSelector: #0.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model 
	"Returns the model associated with the receiver, it can be a class, package...."
	
	^model! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model: aModel
	"Set the model associated with the receiver, it can be a class, package...."
	
	model := aModel! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector
	^widthSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector: anObject
	widthSelector := anObject.! !

CityObject subclass: #District
	instanceVariableNames: 'hisCity buildings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!District commentStamp: '<historical>' prior: 0!
A District is a secondary city abstractions!

!District methodsFor: 'printing' stamp: 'DouailleErwan 4/18/2012 10:02'!
add: aBuilding

	buildings add: aBuilding.
	self widthSelector: (buildings size).
	^ aBuilding.! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/3/2012 14:15'!
buildings
	^buildings! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:32'!
hisCity
	^hisCity.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:32'!
hisCity: aCity
	hisCity := aCity.! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize 
	

	super initialize.
	"buildings := Dictionary new."
	buildings := OrderedCollection new.! !

!District methodsFor: 'printing' stamp: 'douaille 4/11/2012 14:56'!
printOn: aStream

	hisCity ifNotNil: [ aStream
					nextPutAll: hisCity asString;
					nextPutAll: '-> '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' District Name : '; 
					nextPutAll: model name;
					nextPutAll: self buildings size ].! !

!District methodsFor: 'accessing' stamp: 'douaille 4/11/2012 17:52'!
widthSelector
	^super widthSelector sqrt asFloat roundedUp! !

Object subclass: #CityVisualization
	instanceVariableNames: 'win title visualize openGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityVisualization commentStamp: '<historical>' prior: 0!
A CityVisualization is the class who you use to draw 3D visualization of your pakcage which you enter.!

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/18/2012 11:23'!
display
	|fileMenu toolsFirst toolsSecond dock text holder  superClassArray sdock cimport ring |
	win := StandardWindow new.
	title := ValueHolder new contents: 'City Name'.
	visualize := ValueHolder new contents: 'List of package'.
	
	superClassArray := ListModel new list:  {'Version 1.1'.'Version 1.0'}; selectionIndex: 1.
	toolsFirst := win newToolbar: {
	
		win
			newTextEntryFor: title
			getText: #contents
			setText:  #contents:
			help: 'Insert a name for your city'.
		win
			newTextEntryFor: visualize
			getText: #contents
			setText:  #contents:
			help: 'List of package'.
		win
			newButtonFor: self
			getState: nil
			action: #reload
			arguments: nil
			getEnabled: nil
			labelForm: win theme smallDoItIcon 
			help: 'Visualize a new City' translated.
		win
			newDropListFor: superClassArray
          		list: #list
            	getSelected: #selectionIndex
                	setSelected: #selectionIndex:
                	help: '?'
		}.
		
	toolsSecond := win newToolbar: {
	
		win
			newButtonFor: nil
			getState: nil
			action: #saveFile
			arguments: nil
			getEnabled: nil
			labelForm: win theme smallSaveIcon
			help: 'Save file' translated.
		win
			newButtonFor: nil
			getState: nil
			action: #print
			arguments: nil
			getEnabled: nil
			labelForm: win theme smallPrintIcon
			help: 'Print' translated}.
			
			
		holder := StringHolder new.
		
		text := win
			newTextEditorFor: holder
			getText:  #contents
			setText: #contents:
			getEnabled: nil.
			
		dock := win newToolDockingBar.
		dock
			addMorph: toolsFirst;
			addMorph: toolsSecond.
			
		sdock := win newToolDockingBar.
		sdock
			addMorph: toolsSecond.
		cimport := CityImporter new.
		ring := RPackageOrganizer default packageNames.
		cimport cityNamed: 'CodCT' withPackageNames: ring "#('SourceCity' )".
		openGL := GLCity new.
		win
			addMorph: dock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0 @ dock minExtent y));
			"addMorph: sdock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (dock minExtent x corner: 0 @ 0 @0));"
			addMorph: openGL
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@dock minExtent y corner: 0 @ 0)).
		win
			themeChanged;
			title: 'SourceCity';
			openInWorld
		
		! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'douaille 4/6/2012 13:37'!
initialize
	self display! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 14:26'!
reload
	win title: title contents.
	(visualize contents = 'List of package')
	ifTrue: [
		openGL changeModel: RPackageOrganizer default packageNames.
		]
	ifFalse: [
		openGL changeModel: ((visualize contents) asSymbol).
		].! !

Object subclass: #GridRepresentation
	instanceVariableNames: 'grid importer gridMetrics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!GridRepresentation commentStamp: '<historical>' prior: 0!
A GridRepresentation is a matrix where the city is organize
!

!GridRepresentation methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 15:09'!
at: index
	^grid at: index! !

!GridRepresentation methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 15:10'!
do: aBlock
	^grid do: [:e | 
		aBlock valueWithArguments: e].! !

!GridRepresentation methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 14:59'!
importAllBuilding: aDistrict
	|point|
	
	gridMetrics := aDistrict widthSelector asInteger +1.
	
	point := Point new setX: 1 setY: 1.
	aDistrict buildings do:[:district |
		grid add:{point}.
		point setX: (point x) +1 setY: (point y).
		(point x = gridMetrics)
		ifTrue: [
			point setX: 1 setY: (point y)+1.
		].
	].! !

!GridRepresentation methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 15:00'!
importAllDistricts
	|point|
	
	gridMetrics := importer city widthSelector asInteger +1.
	
	point := Point new setX: 1 setY: 1.
	importer city districts do:[:district |
		grid add:{point  . GridRepresentation new importAllBuilding: district}.
		point setX: (point x) +1 setY: (point y).
		(point x = gridMetrics)
		ifTrue: [
			point setX: 1 setY: (point y)+1.
		].
	].! !

!GridRepresentation methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 13:13'!
initialize
	grid := OrderedCollection new! !

!GridRepresentation methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 15:29'!
initialize: aCityImporter
	grid := OrderedCollection new.
	importer := aCityImporter.
	self importAllDistricts.
	! !
